Attribute VB_Name = "modPong"
Public Type Ball
    Left As Single      'Default: Int(Rnd * W)'//Where W is Width
    Top As Single       'Default: Int(Rnd * H)'//Where H is height
    Width As Single     'Default: 16
    Height As Single    'Default: 16
    VelocityX As Single 'Default: 3
    VelocityY As Single 'Default: 0
    Color As OLE_COLOR  'Default: vbWhite
End Type
Type Balls
    Count As Integer
    Balls() As Ball
End Type
Public Type DLine   'DLine because most forms have the name 'line' restricted
                    'I neglected to use the [Line] usage because it is just
                    'a pain.
    X1 As Single
    Y1 As Single
    X2 As Single
    Y2 As Single
    Color As OLE_COLOR
End Type
Public Type DLines
    Count As Integer
    Lines() As DLine
End Type
Public Type Paddle
    Left As Single
    Top As Single
    Width As Single
    Height As Single
    Lines As DLines
    Color As OLE_COLOR
End Type
Type Paddles
    Count As Long
    Paddles() As Paddle
End Type
Public Type PongGame
    Score As Long
    Balls As Balls
    Lines As DLines
    Level As Byte
    Paddles As Paddles
End Type

Public Sub AddBall(Balls As Balls, Left As Single, Top As Single, Optional Width As Single = m_gl_DefBWid, Optional Height As Single = m_gl_DefBHei, Optional Color As OLE_COLOR = vbWhite)
    If Balls.Count = 0 Then
        ReDim Balls.Balls(1 To Balls.Count + 1)
    Else
        ReDim Preserve Balls.Balls(1 To Balls.Count + 1)
    End If
    Balls.Count = Balls.Count + 1
    With Balls.Balls(Balls.Count)
        .Left = Left
        .Top = Top
        .Width = Width
        .Height = Height
        .Color = Color
    End With
End Sub

Public Function CheckBallToLine(Ball As Ball, Line As DLine, Optional Left As Single, Optional Top As Single) As Boolean
    Dim m_lngXSlope As Long
    Dim m_lngYSlope As Long
    Dim m_lngLoopValX As Long
    Dim m_lngLoopValY As Long
    m_lngYSlope = (Line.Y1 - Line.Y2) / IIf((Line.X1 - Line.X2) = 0, 1, (Line.X1 - Line.X2))
    If m_lngYSlope < 0 Then
        m_lngXSlope = (Line.X1 - Line.X2) / IIf((Line.Y1 - Line.Y2) = 0, 1, (Line.Y1 - Line.Y2))
    Else
        m_lngXSlope = -1
    End If
    'First we need to get the slope...
    If Line.X1 = Line.X2 Then
        For m_lngLoopValY = Line.Y1 To Line.Y2
            If (Ball.Left <= Line.X1 + m_lngLoopValX + Left) And (Ball.Top <= (Line.Y1 + Top + m_lngLoopValY)) And (Ball.Width + Ball.Left >= Line.X1 + m_lngLoopValX + Left) And (Ball.Height + Ball.Top >= Top + Line.Y1 + m_lngLoopValY) Then
                CheckBallToLine = True
                Exit Function
            End If
            m_lngLoopValX = m_lngLoopValX + (Line.X1 - Line.X2) / IIf((Line.Y1 - Line.Y2) = 0, 1, (Line.Y1 - Line.Y2))
        Next
    Else
        For m_lngLoopValX = Line.X1 To Line.X2
            If (Ball.Left <= Line.X1 + m_lngLoopValX + Left) And (Ball.Top <= (Line.Y1 + Top + m_lngLoopValY)) And (Ball.Width + Ball.Left >= Line.X1 + m_lngLoopValX + Left) And (Ball.Height + Ball.Top >= Top + Line.Y1 + m_lngLoopValY) Then
                CheckBallToLine = True
                Exit Function
            End If
            m_lngLoopValY = m_lngLoopValY + (Line.Y1 - Line.Y2) / IIf((Line.X1 - Line.X2) = 0, 1, (Line.X1 - Line.X2))
        Next
    End If
End Function

Public Sub AddLine(Lines As DLines, X1 As Single, X2 As Single, Y1 As Single, Y2 As Single, Optional Color As OLE_COLOR = vbWhite)
    If Lines.Count = 0 Then
        ReDim Lines.Lines(1 To Lines.Count + 1)
    Else
        ReDim Preserve Lines.Lines(1 To Lines.Count + 1)
    End If
    Lines.Count = Lines.Count + 1
    With Lines.Lines(Lines.Count)
        .X1 = X1
        .X2 = X2
        .Y1 = Y1
        .Y2 = Y2
        .Color = Color
    End With
End Sub

Public Sub DrawLine(Line As DLine, Canvas As Object, Optional Left As Single, Optional Top As Single)
    Canvas.Line (Line.X1 + Left, Line.Y1 + Top)-(Line.X2 + Left, Line.Y2 + Top), Line.Color
End Sub

Public Sub AddPaddle(Paddles As Paddles, Left As Single, Top As Single, Width As Single, Height As Single, Optional Color As OLE_COLOR = vbWhite)
    With Paddles
        If .Count = 0 Then
            ReDim .Paddles(1 To .Count + 1)
        Else
            ReDim Preserve .Paddles(1 To .Count + 1)
        End If
        .Count = .Count + 1
        With .Paddles(.Count)
            .Color = Color
            .Left = Left
            .Width = Width
            .Top = Top
            .Height = Height
        End With
    End With
End Sub

Public Sub DrawLines(Lines As DLines, Canvas As Object, Optional Left As Single, Optional Top As Single)
    Dim m_lngLoop As Long
    With Lines
        For m_lngLoop = 1 To .Count
            DrawLine .Lines(m_lngLoop), Canvas, Left, Top
        Next
    End With
End Sub
